Parity game---poj1733

Description

Now and then you play the following game with your friend. Your friend writes down a sequence consisting of zeroes and ones. You choose a continuous subsequence (for example the subsequence from the third to the fifth digit inclusively) and ask him, whether this subsequence contains even or odd number of ones. Your friend answers your question and you can ask him about another subsequence and so on. Your task is to guess the entire sequence of numbers.

You suspect some of your friend‘s answers may not be correct and you want to convict him of falsehood. Thus you have decided to write a program to help you in this matter. The program will receive a series of your questions together with the answers you have received from your friend. The aim of this program is to find the first answer which is provably wrong, i.e. that there exists a sequence satisfying answers to all the previous questions, but no such sequence satisfies this answer.

Input

The first line of input contains one number, which is the length of the sequence of zeroes and ones. This length is less or equal to 1000000000. In the second line, there is one positive integer which is the number of questions asked and answers to them. The number of questions and answers is less or equal to 5000. The remaining lines specify questions and answers. Each line contains one question and the answer to this question: two integers (the position of the first and last digit in the chosen subsequence) and one word which is either `even‘ or `odd‘ (the answer, i.e. the parity of the number of ones in the chosen subsequence, where `even‘ means an even number of ones and `odd‘ means an odd number).

Output

There is only one line in output containing one integer X. Number X says that there exists a sequence of zeroes and ones satisfying first X parity conditions, but there exists none satisfying X+1 conditions. If there exists a sequence of zeroes and ones satisfying all the given conditions, then number X should be the number of all the questions asked.

Sample Input

10
5
1 2 even
3 4 odd
5 6 even
1 6 even
7 10 odd

Sample Output

3

题意:有一个长度为n的01串,有m句话,每句话说明x到y之间是有奇数(odd)个1还是偶数(even)个1;求的是前几句话是真的;如果全部为真输出m;

每输入一句话时,可以判断是否和之前的话相冲突,用r[i]表示i到i的跟节点之间1的个数是偶数还是奇数,1表示奇数,0代表偶数;

本题的n是10亿,所以不能定义一个10亿的数组;用map<int,int>定义就行

#include<stdio.h>
#include<string.h>
#include<iostream>
#include<algorithm>
#include<math.h>
#include<map>
#define N 105
#define INF 0xfffffff
using namespace std;

//int f[N], r[N];//r[i]代表i到i的跟节点之间的关系;
map<int,int> f;
map<int,int> r;

int Find(int x)
{
    if(!f[x])
        return x;
    int k = f[x];
    f[x] = Find(f[x]);
    r[x] = (r[x]+r[k])%2;
    return f[x];
}
int main()
{
    int px, py, flag, ans, i, n, m, x, y, d;
    char str[15];
    while(scanf("%d", &n)!=EOF)
    {
        flag = 0;
        f.clear();
        r.clear();
        scanf("%d", &m);
        for(i = 1; i <= m; i ++)
        {
            scanf("%d%d%s", &x, &y, str);
            x--;
            if(str[0] == ‘e‘)//偶数是0;奇数是1;
                d = 0;
            else
                d = 1;
            px = Find(x);
            py = Find(y);
            if(px != py)
            {
                f[px] = py;
                r[px] = (r[y] + d - r[x] +2)%2;//画向量图找关系;
            }
            else if(flag==0 && (2 + r[x]-r[y])%2 != d)
            {
                flag = 1;
                ans = i;
            }
        }
        if(flag==0)//如果全部都正确的话输出m;-_-在这wa了一次;
            ans=m+1;
        printf("%d\n", ans-1);
    }
    return 0;
}

#include<stdio.h>
#include<string.h>
#include<iostream>
#include<algorithm>
#include<math.h>
#include<map>
#define N 105
#define INF 0xfffffff
using namespace std;

//int f[N], r[N];//r[i]代表i到i的跟节点之间的关系;
map<int,int> f;
map<int,int> r;

int Find(int x)
{
    if(!f[x])
        return x;
    int k = f[x];
    f[x] = Find(f[x]);
    r[x] = (r[x]+r[k])%2;
    return f[x];
}
int main()
{
    int px, py, flag, ans, i, n, m, x, y, d;
    char str[15];
    while(scanf("%d", &n)!=EOF)
    {
        flag = 0;
        f.clear();
        r.clear();
        scanf("%d", &m);
        for(i = 1; i <= m; i ++)
        {
            scanf("%d%d%s", &x, &y, str);
            x--;
            if(str[0] == ‘e‘)//偶数是0;奇数是1;
                d = 0;
            else
                d = 1;
            px = Find(x);
            py = Find(y);
            if(px < py)
            {
                f[px] = py;
                r[px] = (r[y] + d - r[x]+2)%2;//画向量图找关系;
            }
            else if(px > py)
            {
                f[py] = px;
                r[py] = (r[x] - r[y] - d + 2)%2;
            }

            else if(px==py &&flag==0 && (r[y] - r[x] + 2)%2 != d)
            {
                flag = 1;
                ans = i;
            }
        }
        if(flag==0)//如果全部都正确的话输出m;-_-在这wa了一次;
            ans=m+1;
        printf("%d\n", ans-1);
    }
    return 0;
}

				
时间: 2024-10-25 20:59:58

Parity game---poj1733的相关文章

POJ1733 - Parity game - 并查集

这道题是带权并查集,只需要把权设成0或1就行,分别表示与根节点的关系.因为10亿个点,所以要用到离散化 #include<iostream> #include<stdio.h> #include<algorithm> using namespace std; int p[10005]; int dis[10005]; int ran[10005]; int tot; struct num { char oe[10]; int st,ed; int id; }po[500

【POJ1733】Parity game

[POJ1733]Parity game 题面 vjudge 题解 比较简单的分类并查集 将一个查询操作看作前缀和\(s_r-s_{l-1}\)的奇偶性 将每个点拆成一奇一偶然后分别连边即可 如果一个点的奇点和偶点被连在一起了就判无解即可 代码 #include <iostream> #include <cstdio> #include <cstdlib> #include <cstring> #include <cmath> #include

【poj1733】 Parity game

http://poj.org/problem?id=1733 (题目链接) 题意 一个由0,1组成的序列,每次给出一段区间的奇偶,问哪一条信息不合法. Solution 并查集. 题目中序列的长度有很大,单纯搜索一定会TLE. 我们用s[i]表示前i个数的前缀和,那么a b even意味着s[b]和s[a-1]的奇偶性相同.a b odd意味着s[b]与s[a-1]的奇偶性不同.于是我们根据奇偶性的不同,用并查集依次处理他们之间的关系.当某条信息出现与并查集中记录的信息不符合时,则此信息不合法.

【POJ1733】【带标记并查集】Parity game

Description Now and then you play the following game with your friend. Your friend writes down a sequence consisting of zeroes and ones. You choose a continuous subsequence (for example the subsequence from the third to the fifth digit inclusively) a

poj1733 Parity Game(扩展域并查集)

描述 Now and then you play the following game with your friend. Your friend writes down a sequence consisting of zeroes and ones. You choose a continuous subsequence (for example the subsequence from the third to the fifth digit inclusively) and ask hi

POJ1733 Parity game (美丽的jo)

Description Now and then you play the following game with your friend. Your friend writes down a sequence consisting of zeroes and ones. You choose a continuous subsequence (for example the subsequence from the third to the fifth digit inclusively) a

Parity Game CodeForces - 298C

You are fishing with polar bears Alice and Bob. While waiting for the fish to bite, the polar bears get bored. They come up with a game. First Alice and Bob each writes a 01-string (strings that only contain character "0" and "1") a an

Parity

Parity Time limit: 2.0 secondMemory limit: 64 MB Now and then you play the following game with your friend. Your friend writes down a sequence consisting of zeroes and ones. You choose a continuous subsequence (for example the subsequence from the th

Codeforces 549C The Game Of Parity(博弈)

The Game Of Parity Solution: 这个题只需要分类讨论就可以解决. 先分别统计奇数和偶数的个数. 然后判断谁走最后一步,如果走最后一步时候同时有偶数和奇数,那么走最后一步的赢.如果没有呢,就看剩下的是奇数还是偶数,是偶数不用说,是奇数看剩奇数个还是偶数个. 针对这几种情况讨论一下就可以. #include <bits/stdc++.h> using namespace std; int n, k, o, e; int main() { cin >> n &g

poj 1733 Parity game

Parity game 题意:一个长度为N(N < 1e9)内的01串,之后有K(K <= 5000)组叙述,表示区间[l,r]之间1的个数为odd还是even:问在第一个叙述矛盾前说了几句话? Sample Input 10 N 5 K 1 2 even 3 4 odd 5 6 even 1 6 even (错误) 7 10 odd Sample Output 3 思路:对于判断正误的问题,一定要知道什么情况会导致错误.如样例:当前输入的区间[1,6]的端点均包含于前面输入的端点中时(包含并